//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.ErrorHandlingTest
{
    
    
    /// <summary>
    /// A class that exposes the IErrorHandlingTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ErrorHandlingTestProvider : IFeatureProvider
    {
        
        private IErrorHandlingTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(ErrorHandlingTestProvider).Assembly, "ErrorHandlingTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ErrorHandlingTestProvider(IErrorHandlingTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertRaiseDefinedExecutionErrorObservablyExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (TestErrorException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/ErrorHandlingTest/v1/DefinedExecutionError/TestError", "An error exclusively used for testing purposes", ex.Message);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<RaiseDefinedExecutionErrorRequestDto, EmptyRequest>("RaiseDefinedExecutionError", RaiseDefinedExecutionError);
            registration.RegisterObservableCommand<RaiseDefinedExecutionErrorObservablyRequestDto>("RaiseDefinedExecutionErrorObservably", RaiseDefinedExecutionErrorObservably, ConvertRaiseDefinedExecutionErrorObservablyExceptions);
            registration.RegisterUnobservableCommand<RaiseUndefinedExecutionErrorRequestDto, EmptyRequest>("RaiseUndefinedExecutionError", RaiseUndefinedExecutionError);
            registration.RegisterObservableCommand<RaiseUndefinedExecutionErrorObservablyRequestDto>("RaiseUndefinedExecutionErrorObservably", RaiseUndefinedExecutionErrorObservably, null);
            registration.RegisterUnobservableProperty("RaiseDefinedExecutionErrorOnGet", GetRaiseDefinedExecutionErrorOnGet);
            registration.RegisterObservableProperty("RaiseDefinedExecutionErrorOnSubscribe", GetRaiseDefinedExecutionErrorOnSubscribe, _implementation);
            registration.RegisterUnobservableProperty("RaiseUndefinedExecutionErrorOnGet", GetRaiseUndefinedExecutionErrorOnGet);
            registration.RegisterObservableProperty("RaiseUndefinedExecutionErrorOnSubscribe", GetRaiseUndefinedExecutionErrorOnSubscribe, _implementation);
            registration.RegisterObservableProperty("RaiseDefinedExecutionErrorAfterValueWasSent", GetRaiseDefinedExecutionErrorAfterValueWasSent, _implementation);
            registration.RegisterObservableProperty("RaiseUndefinedExecutionErrorAfterValueWasSent", GetRaiseUndefinedExecutionErrorAfterValueWasSent, _implementation);
        }
        
        /// <summary>
        /// Executes the Raise Defined Execution Error command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest RaiseDefinedExecutionError(RaiseDefinedExecutionErrorRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.RaiseDefinedExecutionError();
                return EmptyRequest.Instance;
            } catch (TestErrorException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/ErrorHandlingTest/v1/DefinedExecutionError/TestError", "An error exclusively used for testing purposes", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Raise Defined Execution Error Observably command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand RaiseDefinedExecutionErrorObservably(RaiseDefinedExecutionErrorObservablyRequestDto request)
        {
            request.Validate();
            return _implementation.RaiseDefinedExecutionErrorObservably();
        }
        
        /// <summary>
        /// Executes the Raise Undefined Execution Error command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest RaiseUndefinedExecutionError(RaiseUndefinedExecutionErrorRequestDto request)
        {
            request.Validate();
            _implementation.RaiseUndefinedExecutionError();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Raise Undefined Execution Error Observably command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand RaiseUndefinedExecutionErrorObservably(RaiseUndefinedExecutionErrorObservablyRequestDto request)
        {
            request.Validate();
            return _implementation.RaiseUndefinedExecutionErrorObservably();
        }
        
        /// <summary>
        /// Gets the current value of the Raise Defined Execution Error On Get property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseDefinedExecutionErrorOnGet()
        {
            try
            {
                return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseDefinedExecutionErrorOnGet, _server));
            } catch (TestErrorException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/ErrorHandlingTest/v1/DefinedExecutionError/TestError", "An error exclusively used for testing purposes", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Raise Defined Execution Error On Subscribe property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseDefinedExecutionErrorOnSubscribe()
        {
            try
            {
                return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseDefinedExecutionErrorOnSubscribe, _server));
            } catch (TestErrorException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/ErrorHandlingTest/v1/DefinedExecutionError/TestError", "An error exclusively used for testing purposes", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Raise Undefined Execution Error On Get property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseUndefinedExecutionErrorOnGet()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseUndefinedExecutionErrorOnGet, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Raise Undefined Execution Error On Subscribe property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseUndefinedExecutionErrorOnSubscribe()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseUndefinedExecutionErrorOnSubscribe, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Raise Defined Execution Error After Value Was Sent property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseDefinedExecutionErrorAfterValueWasSent()
        {
            try
            {
                return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseDefinedExecutionErrorAfterValueWasSent, _server));
            } catch (TestErrorException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/ErrorHandlingTest/v1/DefinedExecutionError/TestError", "An error exclusively used for testing purposes", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Raise Undefined Execution Error After Value Was Sent property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetRaiseUndefinedExecutionErrorAfterValueWasSent()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.RaiseUndefinedExecutionErrorAfterValueWasSent, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Command/RaiseDefinedExecutionError"))
            {
                return typeof(IErrorHandlingTest).GetMethod("RaiseDefinedExecutionError");
            }
            if ((commandIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Command/RaiseDefinedExecutionErrorObse" +
                "rvably"))
            {
                return typeof(IErrorHandlingTest).GetMethod("RaiseDefinedExecutionErrorObservably");
            }
            if ((commandIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Command/RaiseUndefinedExecutionError"))
            {
                return typeof(IErrorHandlingTest).GetMethod("RaiseUndefinedExecutionError");
            }
            if ((commandIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Command/RaiseUndefinedExecutionErrorOb" +
                "servably"))
            {
                return typeof(IErrorHandlingTest).GetMethod("RaiseUndefinedExecutionErrorObservably");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseDefinedExecutionErrorOnG" +
                "et"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseDefinedExecutionErrorOnGet");
            }
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseDefinedExecutionErrorOnS" +
                "ubscribe"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseDefinedExecutionErrorOnSubscribe");
            }
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseUndefinedExecutionErrorO" +
                "nGet"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseUndefinedExecutionErrorOnGet");
            }
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseUndefinedExecutionErrorO" +
                "nSubscribe"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseUndefinedExecutionErrorOnSubscribe");
            }
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseDefinedExecutionErrorAft" +
                "erValueWasSent"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseDefinedExecutionErrorAfterValueWasSent");
            }
            if ((propertyIdentifier == "org.silastandard/test/ErrorHandlingTest/v1/Property/RaiseUndefinedExecutionErrorA" +
                "fterValueWasSent"))
            {
                return typeof(IErrorHandlingTest).GetProperty("RaiseUndefinedExecutionErrorAfterValueWasSent");
            }
            return null;
        }
    }
}

